BeginPackage["MomCum`","Partition`"]

CumToMom::usage = "CumToMom[c_, set_, opts___] implements the cumulants-to-
moments formula. set is an arbitrary set of indices and c an arbitrary
function that computes the cumulant corresponding to a set of indices.
The optional parameter NoOnes->True should be used when the random variable
is known to have zero mean."

MomToCum::usage = "MomToCum[m_, set_, opts___] implements the moments-to-
cumulants formula. set is an arbitrary set of indices and m an arbitrary
function that computes the moment corresponding to a set of indices.
The optional parameter NoOnes->True should be used when the random variable
is known to have zero mean."

Begin["`Private`"]

CumToMom[c_, set_List, opts___] := Apply[Plus,Map[
         (Apply[Times, Map[c, #]])&,
         PartitionAnySet[set,opts]]]

MomToCum[m_, set_List, opts___] := Apply[Plus,Map[
         ((-1)^(Length[#]-1) (Length[#]-1)! Apply[Times, Map[m,#]])&,
         PartitionAnySet[set,opts]]]

End[]
EndPackage[]
Null
