BeginPackage["Partition`"]

PartitionNumberSet::usage = "PartitionNumberSet[n_, opts___] finds all
partitions of the set of integers from 1 to n."

PartitionAnySet::usage = "PartitionAnySet[set_, opts___] finds all partitions of
an arbitrary finite set."

NoOnes::usage = "NoOnes is an option for the partition generator."

Begin["`Private`"]

PartitionAnySet[set_List, opts___] :=
   Module[{l,p},
          l = Length[set];
          p = PartitionNumberSet[l,opts];
          Return[Map[(set[[#]])&,p,{3}]]]

PartitionNumberSet[n_Integer, opts___] := PartitionNumberSet[n,opts] =
    Module[{i,p},
           p = {{{1}}};
           Do[p = AddToAll[p,i,n,opts], {i,2,n}];
           Return[p]]          

AddToAll[p_List, elem_, nmax_Integer, opts___] :=
   Apply[Union,Map[(AddToOne[#,elem,nmax,opts])&,p]]

AddToOne[p_List, elem_, nmax_Integer, opts___] :=
     Filter[Append[Map[(Append[Complement[p,{#}],Append[#,elem]])&,p],
            Append[p,{elem}]],nmax,opts]

Options[Filter] = {NoOnes->False}
Filter[p_List, nmax_Integer, opts___] :=
   Module[{noones,n1sets,pp},
          noones = NoOnes /. {opts} /. Options[Filter];
          If[!noones, Return[p]];
          n1sets[pp_] := Count[Map[Length,pp],1];
          Return[Select[p, (n1sets[#] <= nmax - Length[Flatten[#]])&]]]

End[]
EndPackage[]
Null

