BeginPackage["Qtfd`", "Misc`"]

Wvd::usage = "Wvd[y_] Computes the Wigner-Ville distribution of the data 
sequence y using Nuttal's algorithm. The number of points on each axis (time 
and frequency) is twice the number of points in y."

Begin["`Private`"]

Wvd[y_List] :=
   Module[{k,n,res={},temp,Y},
          n = Length[y];
          Y = RotateRight[InverseFourier[ZeroPad[y,2*n]],n];
          Do[(temp = Take[Y,2*n+2*k+1];
              temp = temp*Conjugate[Reverse[temp]];
              temp = Join[Join[Take[temp,-(n+k+1)],Zeros[-2*k-1]],Take[temp,n+k]];
              temp = n^(0.5)*Fourier[temp];
              res = Append[res,Chop[temp]];),
             {k,-n,-1}];
          Do[(temp = Take[Y,-(2*n-2*k-1)];
              temp = temp*Conjugate[Reverse[temp]];
              temp = Join[Join[Take[temp,-(n-k)],Zeros[2*k+1]],Take[temp,n-k-1]];
              temp = n^(0.5)*Fourier[temp];
              res = Append[res,Chop[temp]];),
             {k,0,n-1}];
          Return[res]]

End[]
EndPackage[]
Null
