BeginPackage["Rarma`","ArAlg`","Misc`"]

Rarma::usage = "Rarma[a_, b_, sigu2_, m_] computes the covariances of an ARMA
process of orders 0 through m."

Garma::usage = "Garma[a_, b_, m_] computes the correlation 
coefficients of an ARMA process of orders 1 through m."

Begin["`Private`"]

Rar1[a_List, sigu2_, mar_Integer] :=
    Module[{p,r},
          p = Length[a] -1 ;
          r = Inverse[Toeplitz[a,Prepend[Zeros[p],a[[1]]]]
          + Hankel[a,Prepend[Zeros[p],a[[p+1]]]]] . Prepend[Zeros[p], sigu2];
          r[[1]] = 2*r[[1]];
          If[mar <= p, r = Take[r,mar+1],
             Do[r = Append[r, -Drop[a,1] . Reverse[Take[r,-p]]], {mar-p}]];
          Return[r]]

Rar[a_List, sigu2_, mar_Integer] := KtoR[AtoK[a], sigu2, mar]

Rarma[a_List, b_List, sigu2_, m_Integer] :=
   Module[{p,q,r,rar},
          p = Length[a] - 1;
          q = Length[b] - 1;
          rar = Rar[a,sigu2,m+q];
          If[q == 0, Return[rar]];
          rar = Join[Reverse[Take[rar,{2,q+1}]],rar];
          r = Convolution[rar, Convolution[b,Reverse[b]]];
          Return[Take[r,{2*q+1,2*q+m+1}]]]

Garma[a_List, b_List, m_Integer] :=
   Module[{r},
         r = Rarma[a,b,1,m];
         Return[(r[[1]])^(-1) Rest[r]]]

End[]
EndPackage[]
Null
