BeginPackage["Spectrum`","Misc`"]

Spectrum::usage = "Spectrum[a_, b_, sigu2_, omega_] computes the spectral 
density of an ARMA process with parameters a, b, sigu2.  If omega is an 
integer, it gives a list of spectrum values at omega frequency points equally
spaced in the range [0, pi].  If omega is a list of radian frequencies, it
computes the spectrum values at those frequencies."

Begin["`Private`"]

Spectrum[a:{__?NumberQ}, b:{__?NumberQ}, sigu2_?NumberQ, omega_?PosIntQ] :=
   Spectrum[a,b,sigu2,N[(Range[omega]-1)*Pi/omega]]

Spectrum[a:{__?NumberQ}, b:{__?NumberQ}, sigu2_?NumberQ, omega:{__?NumberQ}] :=
   Module[{w},
          w = N[Exp[I omega]];
          Return[sigu2*(Abs[Horner[b,w]/Horner[a,w]])^2]]

End[]
EndPackage[]
Null
